/* JDBC example program using Oracle thin-client database driver - 
*   browser or appletviewer running Java applet must be on same machine
*   as Oracle database driver and server
*   Original example by Sangeeta Aggarwal, modified by NJM 4/16/97 */

import java.io.*;
import java.awt.*;
import java.rmi.*;
import java.applet.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;              

public class DBCApplet extends Applet {
	
    private DisplayPanel dp;	
    public DBC obj;
    public Panel headerPanel;
    private boolean isClose = true;

    public void init() {
        String url = getParameter("url");
        System.out.println("URL" + url);
        try {
            obj = (DBC) Naming.lookup(url);
        }
        catch (Exception ex) {
            System.out.println("DBCApplet: Exception-*--> " + ex) ;
            ex.printStackTrace();
        }
    }

    public DBCApplet() {
  	setBackground(Color.lightGray);
	headerPanel = new Panel();
	headerPanel.setFont(new Font("Helvetica", Font.PLAIN, 24));
        headerPanel.add(new Label("Database Connectivity Test"));
        add("North", headerPanel);                      	
	add("Center", dp = new DisplayPanel());
	add("South",  new ControlPanel(this));
    }


    public void search(String a) {
            try {
                obj.search(a);
                dp.showResult(obj.getName(), obj.getAge(), obj.getOcc());

            } catch (Exception ex) {
                System.out.println("DBCApplet: Exception-> " + ex) ;
                ex.printStackTrace();
            }
        }

    public void open() {
            try {
                obj.open();
            } catch (Exception ex) {
                System.out.println("DBCApplet: Exception-> " + ex) ;
                ex.printStackTrace();
            }
    }
 
    public void close() {
            try {
                obj.close();
            } catch (Exception ex) {
                System.out.println("DBCApplet: Exception-> " + ex) ;
                ex.printStackTrace();
            }
    }
    public void destroy() {
        close();
    }
}

class ControlPanel extends Panel implements ActionListener {
    private DBCApplet parent;
    private TextField name;
    private Label lbl;
    Panel searchPanel;
    Panel connectionPanel;
    Button connectButton, closeButton, searchButton, clearButton;
	
    public ControlPanel(DBCApplet clt) {
	parent = clt;
        setLayout(new BorderLayout());
	setFont(new Font("Helvitica", Font.PLAIN, 14));
        searchPanel = new Panel();
        connectionPanel = new Panel();
        connectButton = new Button("Connect");
        closeButton = new Button("Close");
        searchButton = new Button("Search");
        clearButton = new Button("Clear");
        connectButton.addActionListener(this);
        closeButton.addActionListener(this);
        searchButton.addActionListener(this);
        clearButton.addActionListener(this);

        connectionPanel.add(connectButton);        
        connectionPanel.add(closeButton);
        searchPanel.add(lbl = new Label("Enter name to search"));
        searchPanel.add(name = new TextField(20));
        searchPanel.add(searchButton);
        searchPanel.add(clearButton);
        add("North",connectionPanel);
        add("South",searchPanel);
      }
     
      // handle action events for the button components
      public void actionPerformed(ActionEvent event) {
        String buttonLabel = event.getActionCommand();
 
        if(buttonLabel.equals("Search")) {
          try {
            System.out.println("search for name: " + name.getText());
            parent.search(name.getText());
	    
          }
          catch (Exception ex) {
          }
        }
        if(buttonLabel.equals("Clear")) {                         
          name.setText("");
        }
        if(buttonLabel.equals("Connect")) {
	  try {
          parent.open();
          }
	  catch (Exception ex) {
          }
        }
        if(buttonLabel.equals("Close")) {
	  try {
              parent.close();
          }
	  catch (Exception ex) {
          }
        }
      }
}

class DisplayPanel extends Panel {
    TextArea resultArea;
    String nodatagot = "Sorry! There is no such person by that name.";

    public DisplayPanel() {
	setLayout(new BorderLayout(10,10));
	resultArea = new TextArea(15,60);
	resultArea.setBackground(Color.white);
	add("Center",resultArea);
    }

    public void showResult(String Name, String Age, String Occ) {
      if((Name == null) || Name.equals("")) {
        resultArea.setFont(new Font("Times-Roman", Font.PLAIN,18));
        setForeground(Color.red);
        resultArea.setText("\n\n\n " + nodatagot);
      }

      // otherwise, display the results
      else {
        resultArea.setFont(new Font("Times-Roman", Font.PLAIN,16));
        setForeground(Color.black);
        resultArea.setText("\n\n Name       : " + Name +
                       "\n Age        : " + String.valueOf(Age) +
                       "\n Occupation : " + Occ + "\n");           
    }		       		
  }
}
